# $Id: Makefile.texas,v 1.7 1995/03/03 13:25:15 steve Exp $
# Copyright (c) 1995
#         Whitehead Institute for Biomedical Research. All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# 1.      Redistributions must reproduce the above copyright notice, this
# list of conditions and the following disclaimer in the  documentation
# and/or other materials provided with the distribution.  Redistributions of
# source code must also reproduce this information in the source code itself.
# 
# 2.      If the program is modified, redistributions must include a notice
# (in the same places as above) indicating that the redistributed program is
# not identical to the version distributed by Whitehead Institute.
# 
# 3.      All advertising materials mentioning features or use of this
# software  must display the following acknowledgment:
#         This product includes software developed by the
#         Whitehead Institute for Biomedical Research.
# 
# 4.      The name of the Whitehead Institute may not be used to endorse or
# promote products derived from this software  without specific prior written
# permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE WHITEHEAD INSTITUTE ``AS IS'' AND  ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE  ARE
# DISCLAIMED. IN NO EVENT SHALL THE WHITEHEAD INSTITUTE BE LIABLE  FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL  DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS  OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)  HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.


KEEP_STATE:
.SUFFIXES:
.SUFFIXES:      .o .cc .C .c .td .tdf .tni $(SUFFIXES)
# Site-specific macros:
include ../make_include

CC_OPTIONS=-g
CC = g++
STYLE = gnu
CC_BASE=-I/usr/local/lib/gcc-lib/sparc-sun-sunos4.1.3/2.5.8/include/ -I/usr/local/include 

LDFLAGS = 

LIBS = libfl.a -lm 

EXEC = lbback-MM

# TEXAS should be defined for lbback-texas.
# GETRUSAGE should be defined if the target system offers the getrusage
# function.
#CCFLAGS=$(CC_BASE) -DTEXAS -DUSE_INDEX -DGETRUSAGE $(CC_OPTIONS) $(INCLUDE) 

CCFLAGS=$(CC_BASE) -DUSE_INDEX -DMAIN_MEMORY -DGETRUSAGE $(CC_OPTIONS) $(INCLUDE) 

times.o : $(VLIB)
	ar x $(VLIB)/libc.a times.o

OBJECTS1=\
   btree.o \
   dd_ops.o \
   lex.yy.o \
   ql.tab.o\
   ql_adornment.o \
   ql_adornment_map.o \
   ql_args.o \
   ql_dd.o \
   ql_error.o \
   ql_eval.o \
   ql_iterator.o \
   ql_term.o \
   collated_tags.o \
   id_index_entry.o \
   material.o \
   safe.o \
   step.o \
   value.o \
   list.o \
   basics.o \
   builtin1.o \
   builtin2.o \
   builtin3.o \
   delete.o \
   insert.o \
   texas_imp_code.o \
   material_set.o \
   ql_builtin_impl.o \
   ql_unimplemented.o \
   step_query.o \
   tag_query.o \
   $()

OBJECTS=$(OBJECTS1) times.o ql_dd_entry.o main.o
#TEXASTNIS = $(OBJECTS:.o=.tni)
#TEXASTDS = $(OBJECTS:.o=.td)
ALL_OBJS = $(OBJECTS) 

all : $(EXEC)                 

$(EXEC): $(ALL_OBJS) 
	$(CC) $(CCFLAGS) $(ALL_OBJS) -o $@ $(LDFLAGS) $(LIBS)

.C.o:
	$(CC) -c $(CCFLAGS) $<       

.c.o:
	$(CC) -c $(CCFLAGS) $<
.cc.o:
	$(CC) -c $(CCFLAGS) $<

lex.yy.c : ql.l
	make -f Makefile.general lex.yy.c

ql.tab.c ql.tab.h: ql.y
	make -f Makefile.general ql.tab.c

# Assume changing the Makefile means there was a source code change
TAGS: Makefile
	etags --defines --typedefs-and-c++ *.[CHc]

depend: ql.tab.h ql.tab.c lex.yy.c
	makedepend $(G++_INCLUDES) -I$(TEXASDIR) -- $(CCFLAGS) --  -f.depend *.[Cc]
        
# The following because the #define LABBASE_USER is defined in ../make_include
main.o : ../make_include


# TestCenter:  I haven't figured out how make lbback/texas run as a proofed
# executable under TestCenter.  One problem appears to be that Texas redefines
# malloc, thought there might be additional problems (for example, the
# the initial line number became 0 instead of 1 in the proofed executable).
# If the only problem is the redefinition of malloc, it might be possible
# suppress a relatively few errors and still use TestCenter.

distclean : clean

clean : tidy
	rm -f *.o lbback-MM 

tidy:
	rm -f *~ core *.bak

include .depend
