/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


#ifndef DD_OPS_H
#define DD_OPS_H

#ifndef BASICS_H
#include "basics.H"
#endif

#ifndef VALUE_H
#include "value.H"
#endif

#ifndef TAG_H
#include "tag.H"
#endif

#ifndef QL_BUILTIN_IMPL_H
#include "ql_builtin_impl.H"
#endif

class QL_DD_Entry;
class QL_Term;
class QL_Iterator_State;

class DD_Ops
{
  friend class QL_DD;
  static void add_hardwired(QL_DD_Entry *);
  // add_persistent is a member of QL_DD, because 
  // it needs to be public.
  static void add_all_dd_kinds();
  static void add_dd_kind(char*, Write_implementation);
  static void add_dd_tag(char*, Value::tv_type_id, Tag);
  // For adding a builtin; add_builtin either succeeds or
  // aborts the program.
  static void add_builtin(char *identifier, char *adornment,
		   Builtin_First_Fn first,
                   Builtin_Next_Fn next=0,
		   Write_implementation ii=0,
		   Write_implementation di=0,
		   Write_implementation ui=0);

  static void add_hardwired_tags();
  static void add_1_hardwired_tag(char *, Value::tv_type_id, Tag,
				  int create_only=0);
  static void add_1_step_kind_if_needed(char*);
  static void add_builtins();
  static void add_type_constructors();
  static void add_type_constructor(char*, int has_args=0);
  void DD_Ops::add_hardwireds();

};
#endif



