/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


// $Id: delete.C,v 1.2 1995/02/13 17:49:33 steve Exp $
#ifndef QL_TERM_H
#include "ql_term.H"
#endif

#include "iostream.h"

#ifndef QL_DD_H
#include "ql_dd.H"
#endif

#ifndef QL_DD_ENTRY_H
#include "ql_dd_entry.H"
#endif

#ifndef QL_ARGS_H
#include "ql_args.H"
#endif

#ifndef QL_ERROR_H
#include "ql_error.H"
#endif

#ifndef BASICS_H
#include "basics.H"
#endif

#ifndef VALUE_H
#include "value.H"
#endif

#ifndef MATERIAL_H
#include "material.H"
#endif

#ifndef COLLATED_TAGS_H
#include "collated_tags.H"
#endif

#ifndef STEP_H
#include "step.H"
#endif

#ifndef ID_INDEX_ENTRY_H
#include "id_index_entry.H"
#endif

#ifndef DELETE_H
#include "delete.H"
#endif

#ifndef QL_BUILTIN_IMPL_H
#include "ql_builtin_impl.H"
#endif

static QL_Iterator_State *delete_builtin_or_dd(QL_Term *t)
{
  QL_DD_Entry *entry = t->dd_entry();
  Write_implementation i = entry->implementation_of_delete();
  if (!i) ql_eval_error(t, "No way to delete from");
  else return i(t);
}


static QL_Iterator_State *delete_material(QL_Term *t)
{
  // Delete an instance of a material.
  if (t); // Suppress warning.
  ABORT(1,"NOT IMPLEMENTED");
  return 0; // Suppress warning.
}


static Value::tv_type_id delete_types[1] = { Value::TERM };
BUILTIN_FIRST_DEFINITION(delete_pred,1,0,delete_types,1,0)
{
  QL_Term *arg_t = in_tv[0]->down_to_TERM();

  if (out_tv) t = 0; m = n = 0; // Supress compiler warnings.
  // Switch on the type of the data-dictionary entry:
  QL_DD_Entry::kind k = arg_t->dd_entry()->entry_kind();
  switch (k) {
  case QL_DD_Entry::TAG:
    ql_eval_error(arg_t, "Cannot perform an delete on tag");
    break;
  case QL_DD_Entry::BUILTIN: return delete_builtin_or_dd(arg_t);
  case QL_DD_Entry::MATERIAL_KIND: 
    ql_eval_error(arg_t, "Cannot delete a material instance using");
    break;
  case QL_DD_Entry::STEP_KIND:
    ql_eval_error(arg_t, "Cannot delete a step using");
    break;
  case QL_DD_Entry::DATA_DICTIONARY_KIND:
    ql_eval_error(arg_t, "Cannot delete a data dictionary entry using");
    break;
  default: ABORT(1, "Illegal data-dictionary entry type");
    break;
  }
}

