/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


#ifndef __STRING_H
#include <string.h>
#endif

#ifndef ID_INDEX_ENTRY_H
#include "id_index_entry.H"
#endif

#ifndef MATERIAL_H
#include "material.H"
#endif

#ifndef SAFE_H
#include "safe.H"
#endif

#if !USE_TEXAS_INDEX
Id_Index_Entry::Id_Index_Entry(Material *m, char *id) : _material(m)
{
#ifdef OBJECTSTORE
  os_database *db1 = os_database::of(this);
  os_database *db2 = os_database::of(m);
  ABORT(db1 != db2, "Id must be in the same database");
#endif
  _id = PNEW_ARRAY_ADDR(this,char,strlen(id) + 1);
  safe_strcpy(_id,id);
#ifdef OBJECTSTORE
  b.make_link(&_id,&_id,
	      os_index(Id_Index_Entry,b) - os_index(Id_Index_Entry,_id));
#endif
}

Id_Index_Entry::~Id_Index_Entry()
{
#ifdef OBJECTSTORE
  b.break_link(&_id,&_id,
	       os_index(Id_Index_Entry,b) - os_index(Id_Index_Entry,_id));
#endif
  delete [] _id;
}
#endif
