/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


// $Id: material.H,v 1.3 1995/02/13 17:50:00 steve Exp $
#ifndef MATERIAL_H
#define MATERIAL_H

#ifndef BASICS_H
#include "basics.H"
#endif

#ifndef VALUE_H
#include "value.H"
#endif

#ifndef STEP_H
#include "step.H"
#endif

#ifndef QL_DD_H
#include "ql_dd.H"
#endif

#ifndef BUILTIN_H
#include "builtin.H"
#endif

class QL_DD_Material_Kind_Entry;

class Material : public Value
{
public:
  Material(QL_DD_Material_Kind_Entry *, char *id);
  // The id is copied into the database.

  void add_step(Step *);

  static QL_FIRST_HEADER(iterator_first_0_1);
  static QL_NEXT_HEADER(iterator_next_0_1);
  static QL_FIRST_HEADER(iterator_first_1_0);

  Cursor_Step* step_cursor() const;
  int history_size() const;
  time_t creation_timestamp() const;
  Material *save(P_SEGMENT *dbs);
  void print(ostream& os) const;
  int compare(const Value&) const;


  SLOT(char,delete_marked);
  SLOT(List_Step*,history);
  SLOT(QL_DD_Material_Kind_Entry *,dd_entry);
  SLOT(char*,id);
private:
  static int expected_history_size;
};

Listdeclare(Material);
#endif
