/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


#ifndef QL_ERROR_H
#define QL_ERROR_H

#ifndef BASICS_H
#include "basics.H"
#endif

class QL_Term;

void ql_parse_error(const char *m1, const char *m2=0, const char *m3=0,
		    const char *m4=0, const char *m5=0);
void ql_eval_error(const QL_Term * const t,
		   const char * const m1, const char * const m2=0,
		   const char * const m3=0, const char * const m4=0,
		   const char * const m5=0, const char* const m6=0,
		   const char * const m7=0);

class QL_Position
{
public:
  QL_Position operator += (int);
  add_token(char *); // Not implemented, but useful if we wanted to keep track of 
                     // n recent tokens.
  void nl();
  QL_Position() : _total(0),_line(1),_column(0) {}
  void reset() { _total=0; _line=0; _column = 0; }
  SLOT(int,total);
  SLOT(int,line);
  SLOT(int,column);
};

extern QL_Position error_position;
extern int ql_eval;
#endif

