/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


#ifndef QL_GC_H
#define QL_GC_H

#define QL_GC(TYPE) \
TYPE *TYPE::_garbage_list = 0;\
void TYPE::gc() {\
  while (_garbage_list) {\
    TYPE *p = _garbage_list->_garbage_next;\
    delete _garbage_list;\
    _garbage_list = p;\
  }\
}

#define QL_GC_MEMBERS(TYPE) \
public:\
static void gc();\
private:\
TYPE *_garbage_next;\
static TYPE * _garbage_list
#endif
