/* 
 * Copyright (c) 1995
 *       Whitehead Institute for Biomedical Research. All rights reserved.
 *
 * Released under terms specified in the Copyright file present in the top
 * directory of this distribution.
 */


#ifndef SAFE_H
#define SAFE_H

#ifndef __STRING_H
#include <string.h>
#endif

#ifndef __TIME_H
#include <time.h>
#endif

#ifndef BASICS_H
#include "basics.H"
#endif

extern char *errno_msg();

inline char *safe_strncpy(char* target, char* source, int count)
{
  char *r = strncpy(target, source, count);
  ABORT(!r,errno_msg());
  return r;
}

inline char *safe_strcpy(char* target, const char* source)
{
  char *r = strcpy(target, source);
  ABORT(!r,errno_msg());
  return r;
}

inline time_t safe_time(time_t *result)
{
  time_t t = time(result);
  ABORT(t == -1, errno_msg());
  return t;
}
#endif
